Package org.apache.commons.math3.distribution

# Class EnumeratedIntegerDistribution

java.lang.Object
org.apache.commons.math3.distribution.AbstractIntegerDistribution
org.apache.commons.math3.distribution.EnumeratedIntegerDistribution

All Implemented Interfaces:
  `Serializable`, `IntegerDistribution`

public class EnumeratedIntegerDistribution extends AbstractIntegerDistribution

Implementation of an integer-valued `EnumeratedDistribution`.

Values with zero-probability are allowed but they do not extend the support.
Duplicate values are allowed. Probabilities of duplicate values are combined when computing cumulative probabilities and statistics.

Since:
  3.2
See Also:
  - Serialized Form

## Field Summary

Fields
Modifier and Type
Field
Description
`protected final EnumeratedDistribution<Integer>`
`innerDistribution`
`EnumeratedDistribution` instance (using the `Integer` wrapper) used to generate the pmf.

### Fields inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

`random, randomData`

## Constructor Summary

Constructors
Constructor
Description
`EnumeratedIntegerDistribution(int[] data)`
Create a discrete integer-valued distribution from the input data.
`EnumeratedIntegerDistribution(int[] singletons, double[] probabilities)`
Create a discrete distribution using the given probability mass function definition.
`EnumeratedIntegerDistribution(RandomGenerator rng, int[] data)`
Create a discrete integer-valued distribution from the input data.
`EnumeratedIntegerDistribution(RandomGenerator rng, int[] singletons, double[] probabilities)`
Create a discrete distribution using the given random number generator and probability mass function definition.

## Method Summary

Modifier and Type
Method
Description
`double`
`cumulativeProbability(int x)`
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`.
`double`
`getNumericalMean()`
Use this method to get the numerical value of the mean of this distribution.
`double`
`getNumericalVariance()`
Use this method to get the numerical value of the variance of this distribution.
`int`
`getSupportLowerBound()`
Access the lower bound of the support.
`int`
`getSupportUpperBound()`
Access the upper bound of the support.
`boolean`
`isSupportConnected()`
Use this method to get information about whether the support is connected, i.e.
`double`
`probability(int x)`
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`.
`int`
`sample()`
Generate a random value sampled from this distribution.

### Methods inherited from class org.apache.commons.math3.distribution.AbstractIntegerDistribution

`cumulativeProbability, inverseCumulativeProbability, logProbability, reseedRandomGenerator, sample, solveInverseCumulativeProbability`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

## Field Details

### innerDistribution

protected final EnumeratedDistribution<Integer> innerDistribution
`EnumeratedDistribution` instance (using the `Integer` wrapper) used to generate the pmf.

## Constructor Details

### EnumeratedIntegerDistribution

public EnumeratedIntegerDistribution(int[] singletons, double[] probabilities) throws DimensionMismatchException, NotPositiveException, MathArithmeticException, NotFiniteNumberException, NotANumberException
Create a discrete distribution using the given probability mass function definition.

Note: this constructor will implicitly create an instance of `Well19937c` as random generator to be used for sampling only (see `sample()` and `AbstractIntegerDistribution.sample(int)`). In case no sampling is needed for the created distribution, it is advised to pass `null` as random generator via the appropriate constructors to avoid the additional initialisation overhead.

Parameters:
  `singletons` - array of random variable values.
  `probabilities` - array of probabilities.
Throws:
  `DimensionMismatchException` - if `singletons.length != probabilities.length`
  `NotPositiveException` - if any of the probabilities are negative.
  `NotFiniteNumberException` - if any of the probabilities are infinite.
  `NotANumberException` - if any of the probabilities are NaN.
  `MathArithmeticException` - all of the probabilities are 0.

### EnumeratedIntegerDistribution

public EnumeratedIntegerDistribution(RandomGenerator rng, int[] singletons, double[] probabilities) throws DimensionMismatchException, NotPositiveException, MathArithmeticException, NotFiniteNumberException, NotANumberException
Create a discrete distribution using the given random number generator and probability mass function definition.

Parameters:
  `rng` - random number generator.
  `singletons` - array of random variable values.
  `probabilities` - array of probabilities.
Throws:
  `DimensionMismatchException` - if `singletons.length != probabilities.length`
  `NotPositiveException` - if any of the probabilities are negative.
  `NotFiniteNumberException` - if any of the probabilities are infinite.
  `NotANumberException` - if any of the probabilities are NaN.
  `MathArithmeticException` - all of the probabilities are 0.

### EnumeratedIntegerDistribution

public EnumeratedIntegerDistribution(RandomGenerator rng, int[] data)
Create a discrete integer-valued distribution from the input data. Values are assigned mass based on their frequency.

Parameters:
  `rng` - random number generator used for sampling
  `data` - input dataset
Since:
  3.6

### EnumeratedIntegerDistribution

public EnumeratedIntegerDistribution(int[] data)
Create a discrete integer-valued distribution from the input data. Values are assigned mass based on their frequency. For example, [0,1,1,2] as input creates a distribution with values 0, 1 and 2 having probability masses 0.25, 0.5 and 0.25 respectively,

Parameters:
  `data` - input dataset
Since:
  3.6

## Method Details

### probability

public double probability(int x)
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X = x)`. In other words, this method represents the probability mass function (PMF) for the distribution.

Parameters:
  `x` - the point at which the PMF is evaluated
Returns:
  the value of the probability mass function at `x`

### cumulativeProbability

public double cumulativeProbability(int x)
For a random variable `X` whose values are distributed according to this distribution, this method returns `P(X <= x)`. In other words, this method represents the (cumulative) distribution function (CDF) for this distribution.

Parameters:
  `x` - the point at which the CDF is evaluated
Returns:
  the probability that a random variable with this distribution takes a value less than or equal to `x`

### getNumericalMean

public double getNumericalMean()
Use this method to get the numerical value of the mean of this distribution.

Returns:
  `sum(singletons[i] * probabilities[i])`

### getNumericalVariance

public double getNumericalVariance()
Use this method to get the numerical value of the variance of this distribution.

Returns:
  `sum((singletons[i] - mean) ^ 2 * probabilities[i])`

### getSupportLowerBound

public int getSupportLowerBound()
Access the lower bound of the support. This method must return the same value as `inverseCumulativeProbability(0)`. In other words, this method must return

`inf {x in Z | P(X invalid input: '<'= x) > 0}`.

Returns the lowest value with non-zero probability.

Returns:
  the lowest value with non-zero probability.

### getSupportUpperBound

public int getSupportUpperBound()
Access the upper bound of the support. This method must return the same value as `inverseCumulativeProbability(1)`. In other words, this method must return

`inf {x in R | P(X invalid input: '<'= x) = 1}`.

Returns the highest value with non-zero probability.

Returns:
  the highest value with non-zero probability.

### isSupportConnected

public boolean isSupportConnected()
Use this method to get information about whether the support is connected, i.e. whether all integers between the lower and upper bound of the support are included in the support. The support of this distribution is connected.

Returns:
  `true`

### sample

public int sample()
Generate a random value sampled from this distribution. The default implementation uses the inversion method.

Specified by:
  `sample` in interface `IntegerDistribution`
Overrides:
  `sample` in class `AbstractIntegerDistribution`
Returns:
  a random value